Given an array arr[] of length N and an integer X, the task is to find the number of subsets with a sum equal to X.
Examples:
Input: arr[] = {1, 2, 3, 3}, X = 6
Output: 3
All the possible subsets are {1, 2, 3},
{1, 2, 3} and {3, 3}
Input: arr[] = {1, 1, 1, 1}, X = 1
Output: 4
Approach: A simple approach is to solve this problem by generating all the possible subsets and then checking whether the subset has the required sum. This approach will have exponential time complexity.
Below is the implementation of the above approach:
C++
#include <bits/stdc++.h>
using namespace std;
void printBool( int n, int len)
{
while (n) {
if (n & 1)
cout << 1;
else
cout << 0;
n >>= 1;
len--;
}
while (len) {
cout << 0;
len--;
}
cout << endl;
}
void printSubsetsCount( int set[], int n, int val)
{
int sum;
int count = 0;
for ( int i = 0; i < (1 << n); i++) {
sum = 0;
for ( int j = 0; j < n; j++)
if ((i & (1 << j)) > 0) {
sum += set[j];
}
if (sum == val) {
count++;
}
}
if (count == 0) {
cout << ( "No subset is found" ) << endl;
}
else {
cout << count << endl;
}
}
int main()
{
int set[] = { 1, 2, 3, 4, 5 };
printSubsetsCount(set, 5, 9);
}
|
C
#include <stdio.h>
void printBool( int n, int len)
{
while (n) {
if (n & 1)
printf ( "1 " );
else
printf ( "0 " );
n >>= 1;
len--;
}
while (len) {
printf ( "0 " );
len--;
}
printf ( "\n" );
}
void printSubsetsCount( int set[], int n, int val)
{
int sum;
int count = 0;
for ( int i = 0; i < (1 << n); i++) {
sum = 0;
for ( int j = 0; j < n; j++)
if ((i & (1 << j)) > 0) {
sum += set[j];
}
if (sum == val) {
count++;
}
}
if (count == 0) {
printf ( "No subset is found" );
}
else {
printf ( "%d" , count);
}
}
void main()
{
int set[] = { 1, 2, 3, 4, 5 };
printSubsetsCount(set, 5, 9);
}
|
Java
import java.io.*;
class GFG {
static void printBool( int n, int len)
{
while (n> 0 ) {
if ((n & 1 ) == 1 )
System.out.print( 1 );
else
System.out.print( 0 );
n >>= 1 ;
len--;
}
while (len> 0 ) {
System.out.print( 0 );
len--;
}
System.out.println();
}
static void printSubsetsCount( int set[], int n, int val)
{
int sum;
int count = 0 ;
for ( int i = 0 ; i < ( 1 << n); i++) {
sum = 0 ;
for ( int j = 0 ; j < n; j++)
if ((i & ( 1 << j)) > 0 ) {
sum += set[j];
}
if (sum == val) {
count++;
}
}
if (count == 0 ) {
System.out.println( "No subset is found" );
}
else {
System.out.println(count);
}
}
public static void main(String[] args)
{
int set[] = { 1 , 2 , 3 , 4 , 5 };
printSubsetsCount(set, 5 , 9 );
}
}
|
Python3
def printBool(n, len ):
while n:
if n & 1 :
print ( "1 " )
else :
print ( "0 " )
n = n >> 1
len - = 1
while len :
print ( "0 " )
len - = 1
print ()
def printSubsetsCount( set , n, val):
sum = 0
count = 0
for i in range ( 0 , 1 << n):
sum = 0
for j in range ( 0 , n):
if (i & 1 << j) > 0 :
sum + = set [j]
if ( sum = = val):
count + = 1
if (count = = 0 ):
print ( "No subset is found" )
else :
print (count)
set = [ 1 , 2 , 3 , 4 , 5 ]
printSubsetsCount( set , 5 , 9 )
|
C#
using System;
class GFG {
static void printBool( int n, int len)
{
while (n > 0) {
if ((n & 1) == 1)
Console.Write(1);
else
Console.Write(0);
n >>= 1;
len--;
}
while (len > 0) {
Console.Write(0);
len--;
}
Console.WriteLine();
}
static void printSubsetsCount( int [] set , int n, int val)
{
int sum;
int count = 0;
for ( int i = 0; i < (1 << n); i++) {
sum = 0;
for ( int j = 0; j < n; j++)
if ((i & (1 << j)) > 0) {
sum += set [j];
}
if (sum == val) {
count++;
}
}
if (count == 0) {
Console.WriteLine( "No subset is found" );
}
else {
Console.WriteLine(count);
}
}
public static void Main( string [] args)
{
int [] set = { 1, 2, 3, 4, 5 };
printSubsetsCount( set , 5, 9);
}
}
|
Javascript
function printBool( n, len)
{
while (n!=0) {
if ((n & 1)!=0)
console.log(1);
else
console.log(0);
n/=2 ;
len--;
}
while (len!=0) {
console.log(0);
len--;
}
cout << endl;
}
function printSubsetsCount(set, n, val)
{
let sum;
let count = 0;
for (let i = 0; i < Math.pow(2,n); i++) {
sum = 0;
for (let j = 0; j < n; j++)
if ((i & Math.pow(2,j)) > 0) {
sum += set[j];
}
if (sum == val) {
count++;
}
}
if (count == 0) {
console.log( "No subset is found" );
}
else {
console.log(count);
}
}
let set = [ 1, 2, 3, 4, 5 ];
printSubsetsCount(set, 5, 9);
|
Time Complexity: O(2n), as we are generating all the subsets of the given set. Since there are 2^n subsets, therefore it requires O(2^n) time to generate all the subsets.
Auxiliary Space: O(1), No extra space is required.
However, for smaller values of X and array elements, this problem can be solved using dynamic programming.
Let’s look at the recurrence relation first.
This method is valid for all the integers.
dp[i][C] = dp[i - 1][C - arr[i]] + dp[i - 1][C]
Let’s understand the state of the DP now. Here, dp[i][C] stores the number of subsets of the sub-array arr[i…N-1] such that their sum is equal to C.
Thus, the recurrence is very trivial as there are only two choices i.e. either consider the ith element in the subset or don’t.
Below is the implementation of the above approach:
C++
#include <bits/stdc++.h>
using namespace std;
#define maxN 20
#define maxSum 50
#define minSum 50
#define base 50
int dp[maxN][maxSum + minSum];
bool v[maxN][maxSum + minSum];
int findCnt( int * arr, int i, int required_sum, int n)
{
if (i == n) {
if (required_sum == 0)
return 1;
else
return 0;
}
if (v[i][required_sum + base])
return dp[i][required_sum + base];
v[i][required_sum + base] = 1;
dp[i][required_sum + base]
= findCnt(arr, i + 1, required_sum, n)
+ findCnt(arr, i + 1, required_sum - arr[i], n);
return dp[i][required_sum + base];
}
int main()
{
int arr[] = { 3, 3, 3, 3 };
int n = sizeof (arr) / sizeof ( int );
int x = 6;
cout << findCnt(arr, 0, x, n);
return 0;
}
|
Java
import java.util.*;
class GFG
{
static int maxN = 20 ;
static int maxSum = 50 ;
static int minSum = 50 ;
static int base = 50 ;
static int [][]dp = new int [maxN][maxSum + minSum];
static boolean [][]v = new boolean [maxN][maxSum + minSum];
static int findCnt( int []arr, int i,
int required_sum, int n)
{
if (i == n)
{
if (required_sum == 0 )
return 1 ;
else
return 0 ;
}
if (v[i][required_sum + base])
return dp[i][required_sum + base];
v[i][required_sum + base] = true ;
dp[i][required_sum + base] =
findCnt(arr, i + 1 , required_sum, n) +
findCnt(arr, i + 1 , required_sum - arr[i], n);
return dp[i][required_sum + base];
}
public static void main(String []args)
{
int arr[] = { 3 , 3 , 3 , 3 };
int n = arr.length;
int x = 6 ;
System.out.println(findCnt(arr, 0 , x, n));
}
}
|
Python3
import numpy as np
maxN = 20
maxSum = 50
minSum = 50
base = 50
dp = np.zeros((maxN, maxSum + minSum));
v = np.zeros((maxN, maxSum + minSum));
def findCnt(arr, i, required_sum, n) :
if (i = = n) :
if (required_sum = = 0 ) :
return 1 ;
else :
return 0 ;
if (v[i][required_sum + base]) :
return dp[i][required_sum + base];
v[i][required_sum + base] = 1 ;
dp[i][required_sum + base] = findCnt(arr, i + 1 ,
required_sum, n) + \
findCnt(arr, i + 1 ,
required_sum - arr[i], n);
return dp[i][required_sum + base];
if __name__ = = "__main__" :
arr = [ 3 , 3 , 3 , 3 ];
n = len (arr);
x = 6 ;
print (findCnt(arr, 0 , x, n));
|
C#
using System;
class GFG
{
static int maxN = 20;
static int maxSum = 50;
static int minSum = 50;
static int Base = 50;
static int [,]dp = new int [maxN, maxSum + minSum];
static Boolean [,]v = new Boolean[maxN, maxSum + minSum];
static int findCnt( int []arr, int i,
int required_sum, int n)
{
if (i == n)
{
if (required_sum == 0)
return 1;
else
return 0;
}
if (v[i, required_sum + Base])
return dp[i, required_sum + Base];
v[i, required_sum + Base] = true ;
dp[i, required_sum + Base] =
findCnt(arr, i + 1, required_sum, n) +
findCnt(arr, i + 1, required_sum - arr[i], n);
return dp[i,required_sum + Base];
}
public static void Main(String []args)
{
int []arr = { 3, 3, 3, 3 };
int n = arr.Length;
int x = 6;
Console.WriteLine(findCnt(arr, 0, x, n));
}
}
|
Javascript
<script>
var maxN = 20
var maxSum = 50
var minSum = 50
var base = 50
var dp = Array.from(Array(maxN),
()=>Array(maxSum+minSum));
var v = Array.from(Array(maxN),
()=>Array(maxSum+minSum));
function findCnt(arr, i, required_sum, n)
{
if (i == n) {
if (required_sum == 0)
return 1;
else
return 0;
}
if (v[i][required_sum + base])
return dp[i][required_sum + base];
v[i][required_sum + base] = 1;
dp[i][required_sum + base]
= findCnt(arr, i + 1,
required_sum, n)
+ findCnt(arr, i + 1,
required_sum - arr[i], n);
return dp[i][required_sum + base];
}
var arr = [3, 3, 3, 3];
var n = arr.length;
var x = 6;
document.write( findCnt(arr, 0, x, n));
</script>
|
Time Complexity: O(n * (maxSum + minSum))
The time complexity of the above approach is O(n*(maxSum + minSum)). Here, n is the size of the given array and maxSum + minSum is the total range of values that the required sum can take.
Space Complexity: O(n * (maxSum + minSum))
The space complexity of the approach is also O(n*(maxSum + minSum)). Here, n is the size of the given array and maxSum + minSum is the total range of values that the required sum can take. We need an extra 2-D array of size n*(maxSum + minSum) to store the states of the DP.
Method 2: Using Tabulation Method:
This method is valid only for those arrays which contains positive elements.
In this method we use a 2D array of size (arr.size() + 1) * (target + 1) of type integer.
Initialization of Matrix:
mat[0][0] = 1 because If the sum is 0 then there exists null subset {} whose sum is 0
if (A[i] > j)
DP[i][j] = DP[i-1][j]
else
DP[i][j] = DP[i-1][j] + DP[i-1][j-A[i]]
This means that if the current element has a value greater than the ‘current sum value’ we will copy the answer for previous cases
And if the current sum value is greater than the ‘ith’ element we will see if any of the previous states have already experienced the sum=’j’ and any previous states experienced a value ‘j – A[i]’ which will solve our purpose
C++
#include <bits/stdc++.h>
using namespace std;
int subsetSum( int a[], int n, int sum)
{
int tab[n + 1][sum + 1];
tab[0][0] = 1;
for ( int i = 1; i <= sum; i++)
tab[0][i] = 0;
for ( int i = 1; i <= n; i++)
{
for ( int j = 0; j <= sum; j++)
{
if (a[i - 1] > j)
tab[i][j] = tab[i - 1][j];
else
{
tab[i][j] = tab[i - 1][j] + tab[i - 1][j - a[i - 1]];
}
}
}
return tab[n][sum];
}
int main()
{
int n = 4;
int a[] = {3,3,3,3};
int sum = 6;
cout << (subsetSum(a, n, sum));
}
|
Java
import java.io.*;
import java.lang.*;
import java.util.*;
class GFG{
static int subsetSum( int a[], int n, int sum)
{
int tab[][] = new int [n + 1 ][sum + 1 ];
tab[ 0 ][ 0 ] = 1 ;
for ( int i = 1 ; i <= sum; i++)
tab[ 0 ][i] = 0 ;
for ( int i = 1 ; i <= n; i++)
{
for ( int j = 0 ; j <= sum; j++)
{
if (a[i - 1 ] > j)
tab[i][j] = tab[i - 1 ][j];
else
{
tab[i][j] = tab[i - 1 ][j] +
tab[i - 1 ][j - a[i - 1 ]];
}
}
}
return tab[n][sum];
}
public static void main(String[] args)
{
int n = 4 ;
int a[] = { 3 , 3 , 3 , 3 };
int sum = 6 ;
System.out.print(subsetSum(a, n, sum));
}
}
|
Python3
def subset_sum(a: list , n: int , sum : int ):
tab = [[ 0 ] * ( sum + 1 ) for i in range (n + 1 )]
tab[ 0 ][ 0 ] = 1
for i in range ( 1 , sum + 1 ):
tab[ 0 ][i] = 0
for i in range ( 1 , n + 1 ):
for j in range ( sum + 1 ):
if a[i - 1 ] < = j:
tab[i][j] = tab[i - 1 ][j] + tab[i - 1 ][j - a[i - 1 ]]
else :
tab[i][j] = tab[i - 1 ][j]
return tab[n][ sum ]
if __name__ = = '__main__' :
a = [ 3 , 3 , 3 , 3 ]
n = 4
sum = 6
print (subset_sum(a, n, sum ))
|
C#
using System;
class GFG{
static int subsetSum( int []a, int n, int sum)
{
int [,]tab = new int [n + 1, sum + 1];
tab[0, 0] = 1;
for ( int i = 1; i <= sum; i++)
tab[0, i] = 0;
for ( int i = 1; i <= n; i++)
{
for ( int j = 0; j <= sum; j++)
{
if (a[i - 1] > j)
tab[i, j] = tab[i - 1, j];
else
{
tab[i, j] = tab[i - 1, j] +
tab[i - 1, j - a[i - 1]];
}
}
}
return tab[n, sum];
}
public static void Main(String[] args)
{
int n = 4;
int []a = { 3, 3, 3, 3 };
int sum = 6;
Console.Write(subsetSum(a, n, sum));
}
}
|
Javascript
<script>
function subsetSum( a, n, sum)
{
var tab = new Array(n + 1);
for (let i = 0; i< n+1; i++)
tab[i] = new Array(sum + 1);
tab[0][0] = 1;
for (let i = 1; i <= sum; i++)
tab[0][i] = 0;
for (let i = 1; i <= n; i++)
{
for (let j = 0; j <= sum; j++)
{
if (a[i - 1] > j)
tab[i][j] = tab[i - 1][j];
else
{
tab[i][j] = tab[i - 1][j] + tab[i - 1][j - a[i - 1]];
}
}
}
return tab[n][sum];
}
var n = 4;
var a = new Array(3,3,3,3);
var sum = 6;
console.log(subsetSum(a, n, sum));
</script>
|
Time Complexity: O(sum*n), where the sum is the ‘target sum’ and ‘n’ is the size of the array.
Auxiliary Space: O(sum*n), as the size of the 2-D array, is sum*n.
What if the value of elements starts from 0?
In the case of elements with value 0, your answer can be incorrect with the above solution. Here’s the reason why:-
Consider the below example:
arr[] = {0,1,1,1}
target sum = 3
correct output : 2
As you can see from the dp table, if there is a 0 in the array then it will not take part in the count if it is in the starting position (dp[1][1]).
but if the zero is at the end of the array, then the table would be:
So just sort the array in descending order to achieve the correct output.
Method 3: Space Optimization:
We can solve this problem by just taking care of last state and current state so we can wrap up this problem in O(target+1) space complexity.
Example:-
vector<int> arr = { 3, 3, 3, 3 }; with targetSum of 6;
dp[0][arr[0]] — tells about what if at index 0 we need arr[0] to achieve the targetSum and fortunately we have that solve so mark them 1;
=====dp[0][3]=1
target
Index
|
0 |
1 |
2 |
3 |
4 |
5 |
6 |
0 |
1 |
0 |
0 |
1 |
0 |
0 |
0 |
1 |
1 |
0 |
0 |
2 |
0 |
0 |
1 |
2 |
1 |
0 |
0 |
3 |
0 |
0 |
3 |
3 |
1 |
0 |
0 |
4 |
0 |
0 |
6 |
at dp[2][6] --- tells tell me is at index 2 can count some subsets with sum=6, How can we achieve this?
so we can tell ok i have reached at index 2 by adding element of index 1 or not both case has been added ------ means dp[i-1] we need only bcoz we are need of last index decision only nothing more than that so this why we are using a huge 2D array
just store our running state and last state that's it.
1.Time Complexity:- O(N*val)
2.Space Complexity:- O(Val)
where val and n are targetSum and number of element.
C++
#include <bits/stdc++.h>
using namespace std;
int CountSubsetSum(vector< int >& arr, int val, int n)
{
int count = 0;
vector< int > PresentState(val + 1, 0),
LastState(val + 1, 0);
PresentState[0] = LastState[0] = 1;
if (arr[0] <= val)
LastState[arr[0]] = 1;
for ( int i = 1; i < n; i++) {
for ( int j = 1; j <= val; j++)
PresentState[j]
= ((j >= arr[i]) ? LastState[j - arr[i]]
: 0)
+ LastState[j];
LastState = PresentState;
}
return PresentState[val];
}
int main()
{
vector< int > arr = { 3, 3, 3, 3 };
cout << CountSubsetSum(arr, 6, arr.size());
}
|
Java
import java.io.*;
import java.lang.*;
import java.util.*;
class GFG {
static int subsetSum( int arr[], int n, int val)
{
int [] LastState = new int [val + 1 ];
LastState[ 0 ] = 1 ;
if (arr[ 0 ] <= val) {
LastState[arr[ 0 ]] = 1 ;
}
for ( int i = 1 ; i < n; i++) {
int [] PresentState = new int [val + 1 ];
PresentState[ 0 ] = 1 ;
for ( int j = 1 ; j <= val; j++) {
int notPick = LastState[j];
int pick = 0 ;
if (arr[i] <= j)
pick = LastState[j - arr[i]];
PresentState[j] = pick + notPick;
}
LastState = PresentState;
}
return LastState[val];
}
public static void main(String[] args)
{
int n = 4 ;
int a[] = { 3 , 3 , 3 , 3 };
int sum = 6 ;
System.out.print(subsetSum(a, n, sum));
}
}
|
C#
using System;
using System.Collections.Generic;
class GFG
{
static int subsetSum( int [] arr, int n, int val)
{
int [] LastState = new int [val + 1];
LastState[0] = 1;
if (arr[0] <= val) {
LastState[arr[0]] = 1;
}
for ( int i = 1; i < n; i++) {
int [] PresentState = new int [val + 1];
PresentState[0] = 1;
for ( int j = 1; j <= val; j++) {
int notPick = LastState[j];
int pick = 0;
if (arr[i] <= j)
pick = LastState[j - arr[i]];
PresentState[j] = pick + notPick;
}
LastState = PresentState;
}
return LastState[val];
}
public static void Main (String[] args)
{
int n = 4;
int [] a = { 3, 3, 3, 3 };
int sum = 6;
Console.WriteLine(subsetSum(a, n, sum));
}
}
|
Javascript
function countSubsetSum(arr, val, n) {
let count = 0;
let presentState = new Array(val + 1).fill(0);
let lastState = new Array(val + 1).fill(0);
presentState[0] = lastState[0] = 1;
if (arr[0] <= val) {
lastState[arr[0]] = 1;
}
for (let i = 1; i < n; i++) {
for (let j = 1; j <= val; j++) {
presentState[j] = ((j >= arr[i]) ? lastState[j - arr[i]] : 0) + lastState[j];
}
lastState = [...presentState];
}
return presentState[val];
}
let arr = [3, 3, 3, 3];
console.log(countSubsetSum(arr, 6, arr.length));
|
Python3
def CountSubsetSum( arr, val, n):
count = 0 ;
LastState = [ 0 ] * (val + 1 );
LastState[ 0 ] = 1 ;
if (arr[ 0 ] < = val):
LastState[arr[ 0 ]] = 1 ;
for i in range ( 1 ,n):
PresentState = [ 0 ] * (val + 1 );
PresentState[ 0 ] = 1 ;
for j in range ( 1 ,val + 1 ):
if (j > = arr[i]):
PresentState[j] = LastState[j - arr[i]] + LastState[j];
else :
PresentState[j] = LastState[j]
LastState = PresentState;
return PresentState[val];
arr = [ 3 , 3 , 3 , 3 ];
print (CountSubsetSum(arr, 6 , len (arr)));
|
Time Complexity: O(sum*n), where the sum is the ‘target sum’ and ‘n’ is the size of the array.
Auxiliary Space: O(sum).
Feeling lost in the world of random DSA topics, wasting time without progress? It's time for a change! Join our DSA course, where we'll guide you on an exciting journey to master DSA efficiently and on schedule.
Ready to dive in? Explore our Free Demo Content and join our DSA course, trusted by over 100,000 geeks!
Last Updated :
01 Feb, 2023
Like Article
Save Article